#include <stdio.h>
#include <stdlib.h>

unsigned char bitswap();

#define MODE4_WBYTES 128
#define MODE4_LINES 256

unsigned char ql_mode4_screen[MODE4_LINES][MODE4_WBYTES];

int main()
{
	int width, wentries, height, x_pos, y_pos, wentry, value;
	char *line = NULL;
	size_t linecap = 0;
	ssize_t linelen;

	if ((linelen = getline(&line, &linecap, stdin)) < 1)
	{
		return -1;
	}

	width = atoi(line);

	wentries = width / 8;

	if (width % 8) wentries++;

	if (wentries > MODE4_WBYTES)
		return -1;
	
	if ((linelen = getline(&line, &linecap, stdin)) < 1)
	{
		return -1;
	}

	height = atoi(line);

	if (height > 256)
		return -1;

	x_pos = y_pos = 0;

	for (y_pos = 0; y_pos < MODE4_LINES; y_pos++)
	{
		for (wentry = 0; wentry < wentries; wentry++)
		{
			x_pos = wentry * 2;

			if ((linelen = getline(&line, &linecap, stdin)) < 1)
				break;

			value = (unsigned char) atoi(line);
			value = bitswap(value)^0xff;

			ql_mode4_screen[y_pos][x_pos] = ql_mode4_screen[y_pos][x_pos + 1] = value;
		}
	}

	fwrite(ql_mode4_screen, (size_t) (MODE4_LINES * MODE4_WBYTES), 1, stdout);
}

unsigned char bitswap(byte)
unsigned char byte;
{
	unsigned char val = byte;

	val = (val & 0xF0) >> 4 | (val & 0x0F) << 4;
	val = (val & 0xCC) >> 2 | (val & 0x33) << 2;
	val = (val & 0xAA) >> 1 | (val & 0x55) << 1;
	return val;		
}
